/* Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1996 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/c/bank_example/bank.h,v $
// $Revision: 1.3 $
// $Date: 1998/04/21 12:24:39 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C)
// NAME:	bank.adl
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 	Cyril Inard d'Argence, The Open Group RI - Apr 21, 1998: Modified
//
// DESCRIPTION:
//
//      This example is a redefinition of the classic bank example
//	used in ADL Version 1. It is slightly more complicated to
//	demonstrate some of the new features of ADL Version 2.
// 		
// **********************************************************************/

#ifndef BANK_H
#define BANK_H

#include "bankAccount.h"
#include "bankException.h"

/* The cpp define __ADL__ is used to guard ADL specific language
// from target language source. In ADL2, it is the intention that
// you can specify interfaces in a separate specification file (.adl)
// or you can embbed them directly in the target language source.
*/

#ifndef NULL
#define NULL (void *)0
#endif

#define DEFAULT_MAX_ACCOUNTS 16

extern const int maxAccountsDefault; /* the maximum number of accounts allowed in the bank */
typedef long bank;

void create_bank (int maxAccts) ;

bankAccount *open_account(long amount, long *acctNumber) ;

int
close_account(long acctNumber) ;

#endif
