/*
 Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
 Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
 Copyright (c) 1996-1998 The Open Group
 Copyright (c) 1994-1997 Sun Microsystems Inc.
 
 All rights reserved.
 This technology is a result of the Advanced Software  Enrichment 
 Project of Information-technology Promotion Agency, Japan (IPA).
 
 Permissions  to  use,  copy, modify and distribute this software
 are governed by the terms and conditions set forth in  the  file 
 COPYRIGHT, located in the top directory of this software.

 ************************************************************************

 SCCS:          @(#)bankAux.h	1.1 11/19/96
 PRODUCT:	Assertion Definition Language Translation System
                (ADLTS) Version 2.0
 COMPONENT:	bank example (C)
 NAME:	        bankAux.h
 	
 HISTORY:
 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created

DESCRIPTION:

        These are helper or auxiliary functions used in the evaluation
	and specification of the bank and bankAccount interfaces.
 		
 ************************************************************************/
#ifndef BANKAUX_H
#define BANKAUX_H
#include "bank.h"
#include "bankAccount.h"
#include "bankException.h"

/* these defines will be eventually defined in the runtime
 * library .
 */

#define boolean int
#define true  1
#define false 0

#ifdef NULL
#undef NULL
#define NULL 0
#endif

extern int         maxAccounts;
extern bankAccount **accountList;
extern int         numAccts;

long     get_balance (bankAccount *ba);
long     get_account_number (bankAccount *ba);
boolean  bank_is_full();
boolean  is_account_active(int acct_num);
boolean  is_account_zero  (int acct_num);
int      get_max_accounts();
int      get_active_accounts();

#endif
