//*****************************************************************************
// File Generated by ADLT Version 2.0
//
//        Name: bankAccountACO.cpp
//       ident: $Id: bankAccountACO.cpp,v 1.4 1998/05/28 15:41:16 mallet Exp $
//     $Source: /togcvs/adl2/src/examples/cpp/bank_example/adl_test/bankAccountACO.cpp,v $
//   $Revision: 1.4 $
//       $Date: 1998/05/28 15:41:16 $
//    ADL file: bank.adl
//
//
//*****************************************************************************

#include "bankAccountACO.hh"
#include "ADLResultCodes.h"
#include "ADLString.hh"

bankAccount *bankAccountACO::new_bankAccount() {
  bankAccount *returned_bankAccount = NULL;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions;

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::bankAccount ***");
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_bankAccount = new bankAccount();
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::bankAccount");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  testContext->assertionStart("get_account_number() == 0");
  if (!skipAssertions) {
    long tmp_1 = returned_bankAccount->get_account_number();
   
    tddRes = (tmp_1 == 0);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_account_number()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "get_account_number() == 0\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  testContext->assertionStart("get_balance() == 0");
  if (!skipAssertions) {
    long tmp_1 = returned_bankAccount->get_balance();
   
    tddRes = (tmp_1 == 0);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "get_balance() == 0\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_bankAccount;
}

bankAccount *bankAccountACO::new_bankAccount(long acct, long bal) {
  bankAccount *returned_bankAccount = NULL;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions;

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::bankAccount ***");
    testContext->infoline(adlstr.reset() << "\tlong acct = " << acct);
    testContext->infoline(adlstr.reset() << "\tlong bal = " << bal);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_bankAccount = new bankAccount(acct, bal);
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::bankAccount");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  testContext->assertionStart("get_account_number() == acct");
  if (!skipAssertions) {
    long tmp_1 = returned_bankAccount->get_account_number();
   
    tddRes = (tmp_1 == acct);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_account_number()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "acct\t-> " << acct);
      testContext->infoline(adlstr.reset() << "get_account_number() == acct\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  testContext->assertionStart("get_balance() == bal");
  if (!skipAssertions) {
    long tmp_1 = returned_bankAccount->get_balance();
   
    tddRes = (tmp_1 == bal);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "bal\t-> " << bal);
      testContext->infoline(adlstr.reset() << "get_balance() == bal\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_bankAccount;
}

long bankAccountACO::get_account_number() {
  long returned_long = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof bank.
  bankAccount *bankAccountObject = (bankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::get_account_number ***");
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_long = bankAccountObject->get_account_number();
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::get_account_number");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  testContext->assertionStart("return >= 1");
  if (!skipAssertions) {
    tddRes = (returned_long >= 1);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "return\t-> " << returned_long);
      testContext->infoline(adlstr.reset() << "return >= 1\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_long;
}

long bankAccountACO::get_balance() {
  long returned_long = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof bank.
  bankAccount *bankAccountObject = (bankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::get_balance ***");
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_long = bankAccountObject->get_balance();
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::get_balance");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  testContext->assertionStart("return >= 0");
  if (!skipAssertions) {
    tddRes = (returned_long >= 0);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "return\t-> " << returned_long);
      testContext->infoline(adlstr.reset() << "return >= 0\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_long;
}

long bankAccountACO::deposit(long amt) throw (negativeAmountExc) {
  long returned_long = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof bank.
  bankAccount *bankAccountObject = (bankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  // Saved state checked in assertions
  long sav_tmp_64 = 0;
  long sav_tmp_67 = 0;
  if (!skipAssertions) {
    sav_tmp_64 = amt;
    sav_tmp_67 = bankAccountObject->get_balance();
  }

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::deposit ***");
    testContext->infoline(adlstr.reset() << "\tlong amt = " << amt);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_negativeAmountExc = false;
  negativeAmountExc *thrown_negativeAmountExc = NULL;
  if (!skipAssertions) {
    try {
      returned_long = bankAccountObject->deposit(amt);
    }
    catch (negativeAmountExc& depositExc) {
      wasThrownException = true;
      thrownException = &depositExc;
      wasThrown_negativeAmountExc = true;
      thrown_negativeAmountExc = &depositExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::deposit");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
    
    // evaluation of the abnormal clause
    abnormal = (wasThrown_negativeAmountExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
    
  }

  testContext->assertionStart("@amt < 0 <:> thrown (negativeAmountExc)");
  if (!skipAssertions) {
    bool tmp_1 = (sav_tmp_64 < 0);
    bool tmp_2 = wasThrown_negativeAmountExc;

    tddRes = ((!tmp_1 || abnormal) && 
	      (!(abnormal && tmp_2) || tmp_1));

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@amt\t-> " << sav_tmp_64);
      testContext->infoline(adlstr.reset() << "@amt < 0\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(negativeAmountExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@amt < 0 <:> thrown (negativeAmountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (abnormal) {
    testContext->assertionStart("unchanged (get_balance())");
    if (!skipAssertions) {
      long tmp_1 = sav_tmp_67;
      long tmp_2 = bankAccountObject->get_balance();
      
      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "unchanged (get_balance())\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (normal) {
    testContext->assertionStart("get_balance() == @get_balance() + amt");
    if (!skipAssertions) {
      long tmp_1 = bankAccountObject->get_balance();
      long tmp_2 = sav_tmp_67;
      long tmp_3 = tmp_2 + amt;

      tddRes = (tmp_1 == tmp_3);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "amt\t-> " << amt);
	testContext->infoline(adlstr.reset() << "@get_balance() + amt\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "get_balance() == @get_balance() + amt\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
    testContext->assertionStart("return == get_balance()");
    if (!skipAssertions) {
      long tmp_1 = bankAccountObject->get_balance();
      
      tddRes = (returned_long == tmp_1);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return\t-> " << returned_long);
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "return == get_balance()\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (wasThrownException) throw;

  return returned_long;
}

long bankAccountACO::withdraw(long amt)
  throw (negativeAmountExc, insufficientFundsExc) {
  long returned_long = 0;

  // following cast is safe, we now that the realObject is an
  // instanceof bank.
  bankAccount *bankAccountObject = (bankAccount *)realObject;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  // Saved state checked in assertions
  bool sav_tmp_83 = false;
  bool sav_tmp_84 = false;
  long sav_tmp_87 = 0;
  if (!skipAssertions) {
    sav_tmp_83 = (amt < 0);
    sav_tmp_84 = (bankAccountObject->get_balance() < amt);
    sav_tmp_87 = bankAccountObject->get_balance();
  }

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bankAccount::withdraw ***");
    testContext->infoline(adlstr.reset() << "\tlong amt = " << amt);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_negativeAmountExc = false;
  negativeAmountExc *thrown_negativeAmountExc = NULL;
  bool wasThrown_insufficientFundsExc = false;
  insufficientFundsExc *thrown_insufficientFundsExc = NULL;
  if (!skipAssertions) {
    try {
      returned_long = bankAccountObject->withdraw(amt);
    }
    catch (negativeAmountExc& withdrawExc) {
      wasThrownException = true;
      thrownException = &withdrawExc;
      wasThrown_negativeAmountExc = true;
      thrown_negativeAmountExc = &withdrawExc;
    }
    catch (insufficientFundsExc& withdrawExc) {
      wasThrownException = true;
      thrownException = &withdrawExc;
      wasThrown_insufficientFundsExc = true;
      thrown_insufficientFundsExc = &withdrawExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bankAccount::withdraw");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
    
    // evaluation of the abnormal clause
    abnormal = (wasThrown_negativeAmountExc || wasThrown_insufficientFundsExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
    
  }

  testContext->assertionStart("@(amt < 0) <:> thrown (negativeAmountExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_83;
    bool tmp_2 = wasThrown_negativeAmountExc;

    tddRes = ((!tmp_1 || abnormal) && 
	      (!(abnormal && tmp_2) || tmp_1));

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@(amt < 0)\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(negativeAmountExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@(amt < 0) <:> thrown (negativeAmountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  testContext->assertionStart("@(get_balance() < amt) <:> thrown (insufficientFundsExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_84;
    bool tmp_2 = wasThrown_insufficientFundsExc;

    tddRes = ((!tmp_1 || abnormal) && 
	      (!(abnormal && tmp_2) || tmp_1));

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@(get_balance() < amt)\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(insufficientFundsExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@(get_balance() < amt) <:> thrown (insufficientFundsExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (abnormal) {
    testContext->assertionStart("unchanged (get_balance())");
    if (!skipAssertions) {
      long tmp_1 = sav_tmp_87;
      long tmp_2 = bankAccountObject->get_balance();
      
      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "unchanged (get_balance())\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (normal) {
    testContext->assertionStart("get_balance() == @get_balance() - amt");
    if (!skipAssertions) {
      long tmp_1 = bankAccountObject->get_balance();
      long tmp_2 = sav_tmp_87;
      long tmp_3 = tmp_2 - amt;

      tddRes = (tmp_1 == tmp_3);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "@get_balance()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "amt\t-> " << amt);
	testContext->infoline(adlstr.reset() << "@get_balance() - amt\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "get_balance() == @get_balance() - amt\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
    testContext->assertionStart("return == get_balance()");
    if (!skipAssertions) {
      long tmp_1 = bankAccountObject->get_balance();
      
      tddRes = (returned_long == tmp_1);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return\t-> " << returned_long);
	testContext->infoline(adlstr.reset() << "get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "return == get_balance()\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
    
  }

  if (wasThrownException) throw;

  return returned_long;
}
