// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/cpp/bank_example/bankAccount.cpp,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 13:05:36 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankAccount.cc
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
#include "bankAccount.hh"

bankAccount::bankAccount()
{
  acct_number  = -1;
  balance      = -1;
}

bankAccount::bankAccount(long acct, long bal)
{
  acct_number = acct;
  balance     = bal;

}

long
bankAccount::get_account_number()
{
  return(acct_number);
}

long
bankAccount::get_balance()
{
  return(balance);
}

long
bankAccount::deposit(long amt) throw
   (negativeAmountExc)
{

  if (amt < 0) {
    throw negativeAmountExc();
  }

  balance += amt;
  return balance;
}

long
bankAccount::withdraw(long amt) throw
   (negativeAmountExc,
    insufficientFundsExc)

{
  if (amt < 0) {
    throw negativeAmountExc();
  }
  if (balance - amt < 0) {
    throw insufficientFundsExc();
  }
  balance -= amt;
  return balance;
}
