// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/cpp/bank_example/bankException.cpp,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 13:05:37 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankException.cc
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Oct 23, 1996: Created
// 		
// ************************************************************************
#include "bankException.hh"

bankException::bankException()
{
  err_string = NULL;
}

bankException::bankException(char *str)
{
  if (!str) {
    err_string = NULL;
  }

  err_string = new char [strlen(str) + 1];
  strcpy (err_string,str);

}

bankException::~bankException()
{

  if (err_string) {
    delete [] err_string;
  }
}

char *
bankException::get_string_value()
{

  char *tmp;

  if (err_string) {
    tmp = new char [strlen(err_string) + 1];
    strcpy (tmp,err_string);
  }
  else {
    tmp = err_string;
  }
  return (tmp);

}

accountNotFoundExc::accountNotFoundExc() : bankException("Error: account not found")
{}

accountNotZeroExc::accountNotZeroExc() : bankException("Error: account not zero")
{}

bankFullExc::bankFullExc(): bankException("Error: bank contains the maximum number of account")
{}

bankFullExc::bankFullExc(long numAccts)
{
  char tmp[200];
  sprintf(tmp,
	  "Error: bank contains the maximum number of account %d",
	  numAccts);
  err_string = new char[strlen(tmp) + 1];
  strcpy(err_string, tmp);
  //  bankException((char *)tmp);
}


insufficientFundsExc::insufficientFundsExc() :   bankException("Error: insufficient funds in the account")
{}

invalidAccountExc::invalidAccountExc() : bankException("Error: account is not valid")
{}

invalidAccountNumberExc::invalidAccountNumberExc() : bankException("Error: account number is not valid")
{}

negativeAmountExc::negativeAmountExc() : bankException("Error: amount can not be negative")
{}
