// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/cpp/bank_example/main.cpp,v $
// $Revision: 1.3 $
// $Date: 1998/03/10 17:26:51 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	main.cc
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************

#include <stdio.h>
#include "bank.hh"
#include "bankAux.hh"

main () {

  bank *b;
  bankAccount *ba1, *ba2;


  long acct_number;

  b = new bank(2);

  ba1 = b->open_account (400,acct_number);

  printf ("\n ba1->get_balance() = %d\n",ba1->get_balance());
  try {
    printf ("\n is_account_active() = %d\n",is_account_active(*b, acct_number));
  } catch (accountNotFoundExc& e) {
	printf("\nCaught accountNotFoundExc!\n");
  } catch (...) {
	printf("\nUnexpected exception...\n");
  }
}


#if (defined(__GNUG__) && (__GNUC_MINOR__ < 90))

void terminate () {

  fprintf (stderr,"terminate called, program aborting\n");
  abort();

}

void unexpected() {

  fprintf (stderr,"Uncaught Exception occured\n");

}

#endif
