// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/cpp/bank_example/myBankAccount.cpp,v $
// $Revision: 1.3 $
// $Date: 1998/04/10 13:23:58 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	myBankAccount.cc
// 	
// HISTORY:
// 	Cyrille Bareau, The Open Group RI - Jan 29, 1998: Created
// 		
// ************************************************************************

#include "myBankAccount.hh"

myBankAccount::myBankAccount(long acct, long bal, long over)
{
  acct_number = acct;
  balance = bal;
  overdraft = over;
}

myBankAccount::myBankAccount(long acct, long over)
{
  acct_number = acct;
  balance = 0;
  overdraft = over;
}

long myBankAccount::deposit (long amt) throw (negativeAmountExc) 
{
  printf("In myBankAccount deposit...\n");
  return bankAccount::deposit(amt);
}


long
myBankAccount::withdraw(long amt) throw
   (negativeAmountExc,
    insufficientFundsExc)

{
  if (amt < 0) {
    throw negativeAmountExc();
  }
  if (balance - amt < overdraft) {
    throw insufficientFundsExc();
  }
  balance -= amt;
  return balance;
}


long
myBankAccount::authorizedOverdraft()
{
  return overdraft;
}
