// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// SCCS:        @(#)bankAccount.hh	1.1 11/19/96
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	myBankAccount.hh
// 	
// HISTORY:
// 	Cyrille Bareau, The Open Group RI - Jan 29, 1998: Created
// 		
// ************************************************************************
#ifndef MYBANKACCOUNT_HH
#define MYBANKACCOUNT_HH

#include "bankAccount.hh"

class myBankAccount : public bankAccount {

private:

  char* myName;
  long overdraft;

public:

  myBankAccount(long acct, long bal, long over);

  myBankAccount (long acct, long over);

  long deposit (long amt) throw (negativeAmountExc);

  long withdraw (long amt) throw
    (negativeAmountExc,
    insufficientFundsExc);

  long authorizedOverdraft();

}; /* end of class myBankAccount */
#endif
