//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//  
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//  
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/idl/bank_example/bankServer.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 15:46:32 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example
// NAME:	bankServer.java
// 	
// HISTORY:
// 	Cyril Inard d'Argence, The Open Group - Jan 13, 1998: Created
// 		
// ************************************************************************

package bank_example;

import bank_example.bank_app.*;

import java.io.*;

/**	
 *  class bankServer
 */

public class bankServer {

  public static org.omg.CORBA.ORB theOrb_;

  /** Main
  **/
  public static void main(String[] args) {
    try {
      // create and initialize ORB
      theOrb_ =  org.omg.CORBA.ORB.init(args, null);

      // create Servant and register it with ORB
      bankFactoryImpl servant = new bankFactoryImpl();
      theOrb_.connect(servant);

      // put a stringified  reference to the servant in a file for further
      // retrieving by a client
      PrintWriter pw = new PrintWriter(new FileWriter("BankIOR"));
      pw.print(theOrb_.object_to_string(servant));
      pw.close();

      // wait for invocations from clients
      java.lang.Object sync = new java.lang.Object();
      synchronized (sync) {
         sync.wait();
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
      System.err.println("Bank Server: Exception-> " + ex);
    }
  }


}

// ***********************************************************************
// History Log:
// $Log: bankServer.java,v $
// Revision 1.3  1998/02/27 15:46:32  cinard
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:17  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/02 13:30:05  cinard
// Example of CORBA testing using ADL for Java.
//
// ***********************************************************************

