// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /togcvs/adl2/src/examples/java/stock_example/ProductsBank.java,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 10:49:04 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	stock example
// NAME:	ProductsBank.java
// 	
// HISTORY:
// 	Cyrille Bareau, The Open Group RI - Nov 1997: Created
// 		
// ************************************************************************

package stock_example;

import java.util.*;


public class ProductsBank {

  static private Hashtable h = new Hashtable();

  static {
    put("p1", 10);
    put("p2", 100);
    put("p3", 1000);
    /*
      put("p4", 100);
      put("p5", 100);
      put("p6", 100);
      put("p7", 100);
      */
  }

  static public void put(String symbol, int price) {
    h.put(symbol, new Integer(price));
  }

  static public int get(String symbol) throws UnknownProductExc {
    Object ret = h.get(symbol);
    if (ret == null)
      throw (new UnknownProductExc());
    else return ((Integer)ret).intValue();
  }

  static public boolean exists(String symbol) {
    return h.containsKey(symbol);
  }

  static public Enumeration keys() {
    return h.keys();
  }

  static public Enumeration elements() {
    return h.elements();
  }

}
