//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togcvs/adl2/src/runtime/c/ADLLiteralSet.h,v $
// $Revision: 1.3 $
// $Date: 1998/05/08 20:21:07 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C Runtime Environment - Test directive and factory 
//                                      parameter set class
// NAME:	ADLLiteralSet.h
// 	
// HISTORY:
// 	Shane McCarron, The Open Group - 13 April 1998: Converted
//      Lionel Mallet, The Open Group RI  - Oct  28, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLLiteralSet_h
#define ADLLiteralSet_h

// Note that we get the ADL_LiteralType definition from DataSet.h to avoid a
// race condition at compile time.
//
#include "ADLDataSet.h"
#include "ADLRuntimeException.h"
#include <stdlib.h>

#ifdef WIN32
#include <memory.h>
#endif
#define ADL_chunkNumberOfValues 5

ADLDataSet *ADL_LiteralSetInit(char *label, ADL_LiteralType type, void *vals, int size);

void ADL_LiteralAddValue(ADLDataSet *d, void *value);
void ADL_LiteralAddRangeValues(ADLDataSet *d, long start, long end);

#endif // ADLLiteralSet_h

// ***********************************************************************
// History Log:
// $Log: ADLLiteralSet.h,v $
// Revision 1.3  1998/05/08 20:21:07  shane
// Various modifications, including:
//
// Changed to print certain information only when debugMode is true.
// Changed to actually set debugMode based upon ADL_RPT_MODE in configuration.
// Fixed how pointers are used (man am I stupid).
//
// Revision 1.2  1998/04/29 15:58:40  shane
// Fixed my stupid unions that didn't work right.
//
// Revision 1.1  1998/04/16 12:09:11  shane
// First checkin of complete set.
//
//
// ***********************************************************************
