//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togcvs/adl2/src/runtime/c/ADLPrint.h,v $
// $Revision: 1.5 $
// $Date: 1999/03/17 16:31:15 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C Runtime Environment - Header for default base type print
// 					routines.
// NAME:	ADLPrint.h
// 	
// HISTORY:
//      Shane McCarron, The Open Group - 4 May 1998: Created
//      See Log at end of file
// 		
// ***********************************************************************

#ifndef ADLPrint_h
#define ADLPrint_h

#include <sys/types.h>
#ifdef WIN32
#include <stddef.h>
#endif

void *ADL_palloc(size_t size);
void ADL_pfree();

char *ADL__Print_Default(void *value);
char *ADL__Print_dPointer(void *value);
extern char * (*ADL_Print_Pointer) (void *value);

char *ADL_Print_dBoolean (int value);
extern char * (*ADL_Print_Boolean) (int value);

char *ADL__Print_dInt (int value);
extern char * (*ADL_Print_Int) (int value);

char *ADL__Print_dShort (short int value);
extern char * (*ADL_Print_Short) (short int value);

char *ADL__Print_dUnsignedInt (unsigned int value);
extern char * (*ADL_Print_UnsignedInt) (unsigned int value);

char *ADL__Print_dUnsignedShort (unsigned short int value);
extern char * (*ADL_Print_UnsignedShort) (unsigned short int value);

char *ADL__Print_dLong (long int value);
extern char * (*ADL_Print_Long) (long int value);

char *ADL__Print_dUnsignedLong (unsigned long int value);
extern char * (*ADL_Print_UnsignedLong) (unsigned long int value);

char *ADL__Print_dCharP (const char * const value);
extern char *(*ADL_Print_CharP) (const char * const value);

char *ADL__Print_dChar (char value);
extern char * (*ADL_Print_Char) (char value);

char *ADL__Print_dSignedChar (signed char value);
extern char * (*ADL_Print_SignedChar) (signed char value);

char *ADL__Print_dUnsignedChar (unsigned char value);
extern char * (*ADL_Print_UnsignedChar) (unsigned char value);

char *ADL__Print_dFloat(float value);
extern char * (*ADL_Print_Float) (float value);

char *ADL__Print_dDouble(double value);
extern char * (*ADL_Print_Double) (double value);

char *ADL__Print_dLongDouble(long double value);
extern char * (*ADL_Print_LongDouble) (long double value);

#endif // ADLPrint_h

// ***********************************************************************
// History Log:
// $Log: ADLPrint.h,v $
// Revision 1.5  1999/03/17 16:31:15  mallet
// Bug fixed pr/160: renamed ADL__Print_dUnsigned and ADL_Print_Unsigned
// as ADL__Print_dUnsignedInt and ADL_Print_UnsignedInt.
//
// Revision 1.4  1998/08/06 13:28:45  mallet
// Merged Shane's last change on branch v1_2-patches onto the trunk.
//
// Revision 1.3.2.1  1998/07/22 15:20:54  shane
// Changed to include stddef.h on WIN32 platforms.
//
// Revision 1.3  1998/07/02 14:17:07  bareau
// Modified some function names (suppressed final "Int").
//
// Revision 1.2  1998/05/11 12:54:10  shane
// Changed _ADL_* symbols to ADL__* since our naming convention says that all ADL
// symbols should start with ADL or tdd.
//
// Revision 1.1  1998/05/04 21:01:14  shane
// Initial version.
//
//
// ***********************************************************************
