//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togcvs/adl2/src/runtime/c/ADLRuntimeException.c,v $
// $Revision: 1.1 $
// $Date: 1998/04/16 12:09:13 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   C Runtime Environment - Runtime exception routines
// NAME:        ADLRuntimeException.c
//
// HISTORY:
//      Shane McCarron, The Open Group - 10 April 1998: Converted
//      Lionel Mallet, The Open Group RI - Jan 22, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

#include "ADLRuntimeException.h"
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

static struct ADLRuntimeException {
    ADLRuntimeExceptionType value;
    char msg[ADL_ExceptionLen+1];
} RuntimeException;


void ADL_ClearException() {
    RuntimeException.value = None;
    RuntimeException.msg[0] = '\0';
}

void ADL_RaiseExceptionType(ADLRuntimeExceptionType t) {
    RuntimeException.value = t;
    RuntimeException.msg[0] = '\0';
}

void ADL_RaiseException(ADLRuntimeExceptionType t, char *msg, ...) {
    va_list args;

    vsnprintf(RuntimeException.msg, ADL_ExceptionLen, msg, args);
    RuntimeException.value = t;
}

ADLRuntimeExceptionType ADL_GetExceptionType() {
    return(RuntimeException.value);
}

int ADL_GetException() {
    return(RuntimeException.value);
}

char *ADL_GetExceptionMessage() {
    return(RuntimeException.msg);
}

// ***********************************************************************
// History Log:
// $Log: ADLRuntimeException.c,v $
// Revision 1.1  1998/04/16 12:09:13  shane
// First checkin of complete set.
//
//
// ***********************************************************************
