//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /togcvs/adl2/src/runtime/cpp/ADLRuntimeException.hh,v $
// $Revision: 1.5 $
// $Date: 1998/03/03 22:31:28 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   C++ Runtime Environment - Runtime exception classes
// NAME:        ADLRuntimeException.hh
//
// HISTORY:
//      Lionel Mallet, The Open Group RI - Jan 22, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

#ifndef ADLRuntimeException_hh
#define ADLRuntimeException_hh

typedef enum {ADLRuntime, ADLEndCase, ADLEndTest} ADLRuntimeExceptionType;

class ADLRuntimeException {
private:
  void init_detail_string(ADLRuntimeExceptionType);

protected:
  char *detail;
  ADLRuntimeExceptionType type;

public:
  ADLRuntimeException();
  ADLRuntimeException(ADLRuntimeExceptionType, char *);
  ADLRuntimeException(ADLRuntimeExceptionType);
  ADLRuntimeException(const ADLRuntimeException&);
  ~ADLRuntimeException();

  /**
   * Returns the detail message of the exception.
   * The caller should not free the returned string.
   */
  char *getMessage() { return detail; }

  /**
   * Returns the type of the ADLRuntimeException.
   */
  ADLRuntimeExceptionType getType() { return type; }
};

#endif // ADLRuntimeException_hh

// ***********************************************************************
// History Log:
// $Log: ADLRuntimeException.hh,v $
// Revision 1.5  1998/03/03 22:31:28  shane
// Added handling for WIN32-isms.
// Now compiles cleanly on Win32 - don't know if it runs.
//
// Revision 1.4  1998/02/27 10:01:06  mallet
// Updated copyright notice.
//
// Revision 1.3  1998/02/12 16:04:29  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/01/23 14:50:07  mallet
// Fixed copy constructor signature: should be const ADLRuntimeException&.
//
// Revision 1.1  1998/01/23 10:05:13  mallet
// Exceptions raised from the runtime to notify an EndCase or EndTest
// request from the user. Currently EndTest is partially supported since
// there is no way to notify TET to abort the test execution.
// Due to some limitations in the g++, there is only a single exception
// class with a discriminative field indicating its subtype.
//
// ***********************************************************************
